set -x

mkdir tifXYZ_37 tifXYZ_32 tifXYZ_27 tifXYZ_22 tifXYZ_17 tifXYZ_12 tifXYZ_7 tifXYZ


# Remember 
# source YUV files in $EDRHOME/YDzDx/<e.g. 10k or other>
# encodes are done in $EDRHOME/Tests/<e.g. 10k or other>
fs=0
frames=202
rm -fv *.bin *.yuv

qps=(37 32 27 22 17 12 7)
#Encode
for qp in ${qps[@]}; do
$EDRHOME/HEVC/HM/bin/TAppEncoderStatic -c $EDRHOME/HEVC/HM/cfg/encoder_randomaccess_main10.cfg -i $EDRDATA/YDzDx/Technicolor/SeinePQ2020/YDzDx.yuv -wdt 1920 -hgt 1080 -fr 25 -f $frames -fs $fs --InputBitDepth=12 --ExtendedPrecision=0 --InternalBitDepth=12 --InputChromaFormat=420 -vui 1 --VideoFullRange=0 --ColourDescriptionPresent=1 --ColourPrimaries=9 --TransferCharateristics=15 --MatrixCoefficients=9 --Profile=main-RExt --Tier=main --Level=4.1  -b str$qp.bin -o rec$qp.yuv -q $qp 2>&1 | tee logencoder_$qp  &

done

for job in `jobs -p`
do
echo $job
wait $job 
done


# Decode
for qp in ${qps[@]}; do
$EDRHOME/HEVC/HM/bin/TAppDecoderStatic -b str$qp.bin -o dec$qp.yuv &
done

for job in `jobs -p`
do
echo $job
wait $job 
done



qps=(37 32 27 22 17 12 7)
# decode and reconstruct tiffs
# this part cannot be parallized, but won't take that long
for qp in ${qps[@]}; do
rm -fv  tifXYZ/Xp*tif
$EDRHOME/Tools/tiff2ydzdx/ydzdx2tiff dec$qp.yuv HD1920 2020 -fs $fs -f $frames
rm -fv tifXYZ_$qp/*
mv -fv tifXYZ/* tifXYZ_$qp
done


#./analyze.sh 2>&1 | tee loganalyze





