set -x

mkdir tifXYZ_37 tifXYZ_32 tifXYZ_27 tifXYZ_22 tifXYZ_17 tifXYZ_12 tifXYZ_7 tifXYZ


# Remember 
# source YUV files in $EDRHOME/YDzDx/<e.g. 10k or other>
# encodes are done in $EDRHOME/Tests/<e.g. 10k or other>
### MAKE SURE KNOW HOW MANY FRAMES TO RUN
fs=0
frames=360
rm -fv *.bin *.yuv

qps=(37 32 27 22 17 12 )
###  SET YUV NAME
yuv=$EDRDATA/StEM_DOLBY/StEM_WarmNight_TableYDzDx500.yuv
### Encode VERIFY FRAME RATE
for qp in ${qps[@]}; do
$EDRHOME/HEVC/HM/bin/TAppEncoderHighBitDepthStatic -c $EDRHOME/HEVC/HM/cfg/encoder_randomaccess_main10.cfg -i $yuv -wdt 1920 -hgt 1080 -fr 24 -f $frames -fs $fs --InputBitDepth=12 --InternalBitDepth=12 --InputChromaFormat=420 -crqpofs -12 -vui 0 --Profile=main-RExt --Tier=main --Level=4.1  -b str$qp.bin -o rec$qp.yuv -q $qp 2>&1 | tee logencoder_$qp  &

done

for job in `jobs -p`
do
echo $job
wait $job 
done


# Decode
for qp in ${qps[@]}; do
$EDRHOME/HEVC/HM/bin/TAppDecoderHighBitDepthStatic -b str$qp.bin -o dec$qp.yuv &
done

for job in `jobs -p`
do
echo $job
wait $job 
done




# decode and reconstruct tiffs
# this part cannot be parallized, but won't take that long
for qp in ${qps[@]}; do
rm -fv  tifXYZ/Xp*tif
$EDRHOME/Tools/tiff2ydzdx/ydzdx2tiff dec$qp.yuv HD1920 Y500  -f $frames
rm -fv tifXYZ_$qp/*
mv -fv tifXYZ/* tifXYZ_$qp
done


#./analyze.sh 2>&1 | tee loganalyze





